<html>
<head>
<title>SMBSpider</title>
</head>
<body bgcolor=#ffffff>
<font face="arial,helvetica">
<script language="php">

/* This is SMBSpider, version 0.9 Copyright (c) 2002-2004 Tillmann Steinbrecher 

May be distributed according to the terms of the GNU General Public License,
Version 2. This program comes with NO WARRANTY.

Feedback and patches are welcome - email mail@tillmann-steinbrecher.de */


/***************** Edit the following variables *************/

/* Directory where the list files will be located.
   Make sure commands executed by this PHP script have read and
   write permissions in this dir. */

$listfiledir="/home/tst/listfiles/listen";

/* Maximum number of hits to display in a single search */

$maxhits=300;

/****** No more editing necessary below this line **********/

ini_set("memory_limit", "32M"); 

$linkto=$PHP_SELF;

function banner($text){
  
  echo "<table BORDER=0 CELLSPACING=0 CELLPADDING=7 WIDTH=\"90%\" BGCOLOR=\"#FFCC00\">";
  echo "<tr><td ALIGN=LEFT><b><i><font face=\"arial,helvetica\">$text</font></i></b></td><tr></table><br>";
}



function add_list($link, $raddr){

  global $listfiledir;

  $command = "smb-list $listfiledir";

  $before_list = "<br><center>\n<table border=0 bgcolor=#FFFFFF cellspacing=8\n <tr>\n";
  $after_list = " </tr>\n</table>\n</center>\n";
  $items_per_row=4;
  $before_single_item = '  <td align=center bgcolor=#FFCC00><font face="arial,helvetica">';
  $after_single_item  = "</font></td>\n";
  $newrow = " </tr>\n <tr>";

  echo "<center>";
  banner("List of SMB shares");
  echo "</center>";

  exec($command, $answer);
  sort($answer);

  echo $before_list;

  for($i=0; $i < count($answer); $i++) {
    echo $before_single_item;
    echo "<a href=\"$link?lf=$answer[$i]&dir=\">";
    echo rawurldecode($answer[$i]);
    echo "</a>";
    echo $after_single_item;

  if((($i+1) % $items_per_row)==0 && ($i != (count($answer)-1))) echo $newrow;
		 
}
echo $after_list;

}


function getdirname($dn) {

	$newstr=strstr(substr($dn, 1, strlen($dn)-2), "/");
	if ($newstr==false) $newstr="";
	return $newstr;

}

function getfilename($fn) {

        /* The exact offset of the start of the filename in the ls -lR output 
	   depends on the version of ls. We can't use simple split to retrieve
	   filename, since the filename itself may also contain whitespaces.
	   So we determine the offset of the start of the filename using preg_split,
	   and then use substr */
	   
        $items=preg_split('/ +/', $fn, -1, PREG_SPLIT_OFFSET_CAPTURE);
	$fnitems=$items[7];
        $fnstart=$fnitems[1];
	return substr($fn, $fnstart, strlen($fn)-$fnstart);

}


function getfilesize($fn) {
        $items=preg_split('/ +/', $fn);
        return $items[4];

}

function displayline($line, $linkto, $cd, $dir){

	if($line[0]=="d") $isdir=true; else $isdir=false;

	        $filename=getfilename($line);
	  
	        echo "<b>";
	  
	  	if($isdir) {
		
		      echo "<a href=\"$linkto?dir=";
		      echo rawurlencode($dir);
		      echo rawurlencode("/");
		      echo rawurlencode($filename);
		      echo "&lf=$cd";
		      echo "\">";

		 
		 }
	  
	  	echo $filename;
	  
	  	if($isdir) echo "</a>";
	  

	  	$filesize=getfilesize($line);

	  	if ($isdir){
	  		echo "</b> (directory)<br>";
	        }
	
	  	else {
		        echo "</b> - $filesize bytes<br>";
	        }
	     
	  	echo "\n";


}



function searchfor($rawexp, $dironly, $linkto){

        global $maxhits;

	global $listfiledir;

	$regexp = str_replace(" ", ".{0,50}", $rawexp);

	$temp=$regexp;

	$regexp = str_replace("?", ".", $temp);

	$temp=$regexp;

	$regexp = str_replace("*", ".{0,50}", $temp);


	$command = "smb-search $listfiledir \"$regexp|:$\"";

	echo "<center><table BORDER=0 CELLSPACING=0 CELLPADDING=7 WIDTH=\"90%\" BGCOLOR=\"#FFCC00\">";
	echo "<tr><td ALIGN=LEFT><i><font face=\"arial,helvetica\">";


	echo "<b>Search results for '$rawexp'</b>";

	if($dironly) echo " (searching for directories only)";
        echo ":</font></i></td><tr></table></center><ul>";

	echo "<p>\n";
	echo "<ul>\n";


	exec($command, $answer);



	for($i=0;$i<count($answer);$i++){

		$dirmarker=false;
		$separator=strpos($answer[$i], ":");
		$cdname = substr($answer[$i], 0, $separator);
	
		$rest = substr($answer[$i], $separator+1, strlen($answer[$i])-$separator);

		if($rest[0]=="d") $isdir=true; else $isdir=false;
	
		if($rest[strlen($rest)-1] == ":") {
	
			  $dirmarker = true;
			  $outputloc = true;
			  $currentdir=getdirname($rest);
	
		} 
		
			
		if(!$dirmarker && !(!$isdir && $dironly) && (strlen($rest)>16)) {
	  
			  $hits++;
			  
			  if($hits > $maxhits) {
			  	echo "</ul><p><b><font color=\"#ff0000\">Showing only the first $maxhits results.<br>";
				echo "Please use more specific keywords.</font></b>";
				return;
			  }
	  


		  	  if($outputloc){
	 	  	      echo "</ul><i><br><li>Share <a href=\"$linkto?lf=$cdname&dir=\">";
			      echo rawurldecode($cdname);
			      echo "</a>, directory ";
			      
			      
			      echo "<a href=\"$linkto?dir=";
			      echo rawurlencode($currentdir);
			      echo "&lf=$cdname";
			      echo "\">";
			      if ($currentdir=="") echo "/";
			      else echo $currentdir;
			      echo "</a>:";
			      
			      
			      echo" </li></i><br><br><ul>\n";
		              $outputloc=false;
	                  }	
	
			  displayline($rest, $linkto, $cdname, $currentdir);
                }
	   
	
	}

	if ($hits==0) echo "No occurences found, sorry.";
	else {
		if ($hits > 1) echo "</ul><p>Found $hits results.<ul>";
		else echo "</ul><p>Found only $hits result.<ul>";

        }



	echo "</ul>";
}


function browse($listfile, $dir, $linkto){
	
  	$count=0;
	
	global $listfiledir;
	
	$directory = str_replace("\\'", "'", $dir);

	echo "<li><i>Browsing ";
	if($directory=="") echo "root directory ";
	else echo "directory $directory ";
	echo "on $listfile</i></li><ul><p>";
	
	$listf = rawurlencode($listfile);

	$command = "smb-get $listfiledir $listf";

	exec($command, $answer);	

	if($directory!="") {
		$upperdir = substr($directory, 0, strrpos($directory, "/"));
		if($upperdir==false) $upperdir="";
		
		echo "<i><a href=\"$linkto?dir=";
		echo rawurlencode($upperdir);
		echo "&lf=";
		echo rawurlencode($listfile);
		echo "\">.. [higher level directory]</a></i><br><br>";

	
	}
	
			    	
	for($i=0;$i<count($answer);$i++){

	  if($answer[$i][strlen($answer[$i])-1] == ":") {
		if(getdirname($answer[$i])==$directory){
		  $i+=2;
		  while ($answer[$i]!="") {
		  	displayline($answer[$i], $linkto, $listfile, $directory);
		  	$i++;
			$count++;
		  }
		  echo "</ul><p>Total $count files.\n";
		  return;
		}
		
	  }  
	}
	
	echo "</ul><p>Error - not found.";	  
}

// ********** MAIN *********

if($dircheckbox[0]==1) $dironly = true;
else $dironly = false;


if(isset($term)) {
  if($term=="") { 
    echo "<center>";
    banner("Error: No search term supplied");
    echo "You gotta search for something!<br>";
  } else searchfor($term, $dironly, $PHP_SELF);
}

if(isset($lf) && isset($dir)){
  echo "<center>";
  banner("Browsing $lf");
  echo "</center><ul>";
  browse($lf, rawurldecode($dir), $PHP_SELF);
}


if(isset($list)) {
  add_list($PHP_SELF, $REMOTE_ADDR);
}


// display links at the end

echo "<br>";

echo "</UL>";

if(isset($term)||isset($list)){
  echo "<blockquote>";
  if(isset($list))
     banner("Search shares");
  else
    banner("Search again");
    
 } else {

  echo "<ul><B>SMB<i>spider</i></b> - smb search engine<br></ul><center>";
 
  echo "<table border=0 cellpadding=5 cellspacing=0 bgcolor=#FFCC00 width=95%><tr><td>";
  echo "<blockquote><font face='arial, helvetica'>";
  echo "<b>Enter search term</b> (wildcards '*' and '?' are allowed)";
  echo "</font>";
}
echo "<form action=$PHP_SELF>";
echo "<input type=\"text\" size=40 name = \"term\" value=\"$term\">\n";
echo "<input type = submit value = \"Search\"><br>\n";
echo "<input type=\"checkbox\" name=\"dircheckbox[]\" value=\"1\">\n";
echo " Search for directories only";

if(!isset($list))
    echo "<br><b><a href=$PHP_SELF?list=1>Browse indexed servers</a><br>";
    
echo "</blockquote></td></tr></table>";

echo "<p>\n";

echo "<center><br><font size=-1>SMBSpider Copyright (c) 2002-2004 Tillmann Steinbrecher and Ian Hubbertz<br>";
echo "</center></b>";
	
</script>
</body>
</html>
