bind pub - !smbsearch pub:smbsearch
bind pub - !smbstats pub:smbstats
bind pub - !newdirs pub:newdirs

proc pub:smbsearch {nick uhost handle chan arg} {
 set binary {/usr/local/bin/smbsearch}
 set what [lindex $arg 0]
 foreach line [split [exec $binary $what] "\n"] {
     if { ! [info exists newline($line)] } { set newline($line) 0 } else { set newline($line) [expr $newline($line) + 1] }
     puthelp "NOTICE $nick :$line"}
}


proc pub:newdirs {nick uhost handle chan arg} {
 set binary {/usr/local/bin/newdirs}
 set what [lindex $arg 0]
 puthelp "PRIVMSG #samplechan :$nick, I will send you a listing of newly created directories."
 foreach line [split [exec $binary $what] "\n"] {
     if { ! [info exists newline($line)] } { set newline($line) 0 } else { set newline($line) [expr $newline($line) + 1] }
     puthelp "NOTICE $nick :$line"}
}


proc pub:smbstats {nick uhost handle chan arg} {
 set binary {/usr/local/bin/smbstats}
 set what [lindex $arg 0]
 foreach line [split [exec $binary $what] "\n"] {
     if { ! [info exists newline($line)] } { set newline($line) 0 } else { set newline($line) [expr $newline($line) + 1] }
     puthelp "PRIVMSG #samplechan :$line"}
}

putlog "SMBSpider tools loaded"
